#include <stdio.h>

int read16(unsigned char * buf) {
	return (buf[0]<<8)|buf[1];
}
void write16(int in, unsigned char * buf) {
	buf[0]=in>>8;
	buf[1]=in&0xff;
}
int read32(unsigned char * buf) {
	return (buf[0]<<24)|(buf[1]<<16)|(buf[2]<<8)|buf[3];
}

int main(int argc, char ** argv) {
	FILE * infile,* cryptstream;
	int off,i;
	int xor=0x49e1;
	const int xormult=0x4a57;
	const int xoradd=0x553d;
	unsigned char buf[18];
	int startoff, endoff;

	if (argc!=2) { printf("need 1 argument\n"); return 1; }
	infile=fopen(argv[1],"r+b");
	if (!infile) { printf("failed to open input file\n"); return 1; }


	fread(buf,16,1,infile);
	if (buf[0]!=0x80 || buf[1]!=0x00) {
		printf("not ADX\n");
		return 1;
	}
	if (buf[5]!=18) {
		printf("not 18-byte frames\n");
	}

	startoff=read16(buf+2)+4;
	endoff=(read32(buf+12)+31)/32*18*buf[7]+startoff;

	/* get version */
	fread(buf,4,1,infile);
	if (buf[3]!=8) {
		printf("doesn't seem to be encrypted\n");
		return 1;
	}
	buf[3]=0;
	fseek(infile,0x10,SEEK_SET);
	fwrite(buf,4,1,infile);

	for (off=startoff;off<endoff;off+=18) {
		fseek(infile,off,SEEK_SET);
		fread(buf,18,1,infile);

		//write16(read16(buf)&0x7ff,buf);
		write16(read16(buf)^xor,buf);
		//write16(read16(buf)-xor,buf);
		fseek(infile,off,SEEK_SET);
		fwrite(buf,18,1,infile);

		xor=(xor*xormult+xoradd)&0x7fff;
	}

	/*
	for (i=0;i<0x10;i++) {
		printf("%02x,%d\n",i,scalenibbles[i]);
	}
	*/
}

